#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var yargs = __importStar(require("yargs"));
var aws_setup_1 = require("./aws_setup");
var build_ui_1 = require("./build_ui");
var deploy_1 = require("./deploy");
var path = __importStar(require("path"));
yargs
    .command('deploy', 'Perform a full build and deploy.', {
    builder: {
        'lambdaS3Bucket': {
            description: 'The S3 bucket to store the lambda configuration. Must be in the same account as the lambdas',
            string: true,
            required: true
        },
        'lambdaAccessKeyId': {
            description: 'The Access Key ID of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'lambdaSecretAccessKey': {
            description: 'The Secret Access Key of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'region': {
            description: 'The region of the S3 bucket and lambdas',
            string: true,
            required: true
        },
        's3BucketName': {
            description: 'The name of the S3 bucket',
            string: true,
            required: true
        },
        's3AccountId': {
            description: 'The account ID of the S3 bucket',
            string: true,
            required: true
        }
    },
    handler: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            deploy_1.deploy(args);
            return [2 /*return*/];
        });
    }); }
})
    .command('setup_aws', 'Add extra configuration to the lambda set-up that CloudFoundry wont support. Run after "sam deploy"', {
    builder: {
        'lambdaAccessKeyId': {
            description: 'The Access Key ID of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'lambdaSecretAccessKey': {
            description: 'The Secret Access Key of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'region': {
            description: 'The region of the S3 bucket and lambdas',
            string: true,
            required: true
        },
        's3BucketName': {
            description: 'The name of the S3 bucket',
            string: true,
            required: true
        },
        's3AccountId': {
            description: 'The account ID of the S3 bucket',
            string: true,
            required: true
        }
    },
    handler: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            aws_setup_1.setup(args);
            return [2 /*return*/];
        });
    }); }
})
    .command('write_aws_ui', 'Update the compiled AWS UI lambda with the gzipped base64 encoded UI.', {
    builder: {
        'lambdaAccessKeyId': {
            description: 'The Access Key ID of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'lambdaSecretAccessKey': {
            description: 'The Secret Access Key of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'region': {
            description: 'The region of the S3 bucket and lambdas',
            string: true,
            required: true
        }
    },
    handler: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            build_ui_1.write_to_aws(args.lambdaAccessKeyId, args.lambdaSecretAccessKey, args.region, path.join(__dirname, '..', 'built', 'ui.js'));
            return [2 /*return*/];
        });
    }); }
})
    .command('s3_assets', 'Fetch the Lambda ARN to use as the S3 notification target and the S3 policy. Should be run after a deploy.', {
    builder: {
        'lambdaAccessKeyId': {
            description: 'The Access Key ID of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'lambdaSecretAccessKey': {
            description: 'The Secret Access Key of the account that will host the Lambdas',
            string: true,
            required: true
        },
        'region': {
            description: 'The region of the S3 bucket and lambdas',
            string: true,
            required: true
        },
        's3BucketName': {
            description: 'The name of the S3 bucket',
            string: true,
            required: true
        }
    },
    handler: function (args) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            aws_setup_1.config_for_s3(args);
            return [2 /*return*/];
        });
    }); }
})
    .demandCommand()
    .argv;
